package com.util;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.HashMap;
import java.util.Map;

import net.sf.json.JSONObject;

/**
 * @author 作者姓名: dubaohui
 * @version 创建时间：2015-9-29 下午4:56:12
 * 类说明
 */
public class RequestMessage {
	public static final String DEF_CHATSET = "UTF-8";
    public static final int DEF_CONN_TIMEOUT = 30000;
    public static final int DEF_READ_TIMEOUT = 30000;
    public static String userAgent =  "Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/29.0.1547.66 Safari/537.36";
    //配置您申请的KEY
    public static final String APPKEY ="3bbd4eebe311f16af14c8f38dfa927f1";
    //模板编号
   // public static String tpl_id= "4027";
    //返回格式
    public static String dtype = "json";
    public static String url ="http://v.juhe.cn/sms/send";
 
    //2.发送短信
    public static boolean SendMessage(String phoneno,String code,String tpl_id){
    	boolean sign = false;
        String result =null;
        Map<String, Object> params = new HashMap<String, Object>();//请求参数
            params.put("mobile",phoneno);//接收短信的手机号码
            params.put("tpl_id",tpl_id);//短信模板ID，请参考个人中心短信模板设置
            //"#customername#="+code+"&#employeeno#="+8004+""
            params.put("tpl_value",code);
            //变量名和变量值对。如果你的变量名或者变量值中带有#&amp;=中的任意一个特殊符号，请先分别进行urlencode编码后再传递，&lt;a href=&quot;http://www.juhe.cn/news/index/id/50&quot; target=&quot;_blank&quot;&gt;详细说明&gt;&lt;/a&gt;
            params.put("key",APPKEY);//应用APPKEY(应用详细页查询)
            params.put("dtype",dtype);//返回数据的格式,xml或json，默认json
 
        try {
            result =net(url, params, "GET");
           // System.out.println("---"+result);
            JSONObject object = JSONObject.fromObject(result);
            if(object.getInt("error_code")==0){
               // System.out.println(object.get("result"));
            	sign = true;
            }else{
               // System.out.println(object.get("error_code")+":"+object.get("reason"));
            	sign = false;
            }
        } catch (Exception e) {
            e.printStackTrace();
            sign = false;
        }
        return sign;
    }
 
 
 
    public static void main(String[] args) {
    	//System.out.println(SendMessage("17717522592","收到请回复。。。。。"));
    }
 
    /**
     *
     * @param strUrl 请求地址
     * @param params 请求参数
     * @param method 请求方法
     * @return  网络请求字符串
     * @throws Exception
     */
    public static String net(String strUrl, final Map<String, Object> params,String method) throws Exception {
        HttpURLConnection conn = null;
        BufferedReader reader = null;
        String rs = null;
        try {
            StringBuffer sb = new StringBuffer();
            if(method==null || method.equals("GET")){
                strUrl = strUrl+"?"+urlencode(params);
            }
            URL url = new URL(strUrl);
            conn = (HttpURLConnection) url.openConnection();
            if(method==null || method.equals("GET")){
                conn.setRequestMethod("GET");
            }else{
                conn.setRequestMethod("POST");
                conn.setDoOutput(true);
            }
            conn.setRequestProperty("User-agent", userAgent);
            conn.setUseCaches(false);
            conn.setConnectTimeout(DEF_CONN_TIMEOUT);
            conn.setReadTimeout(DEF_READ_TIMEOUT);
            conn.setInstanceFollowRedirects(false);
            conn.connect();
//            if (params!= null && method.equals("POST")) {
//            	try (DataOutputStream out = new DataOutputStream(conn.getOutputStream())) {
//                    out.writeBytes(urlencode(params));
//                }
//            }
            InputStream is = conn.getInputStream();
            reader = new BufferedReader(new InputStreamReader(is, DEF_CHATSET));
            String strRead = null;
            while ((strRead = reader.readLine()) != null) {
                sb.append(strRead);
            }
            rs = sb.toString();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if (reader != null) {
                reader.close();
            }
            if (conn != null) {
                conn.disconnect();
            }
        }
        return rs;
    }
 
    //将map型转为请求参数型
    public static String urlencode(Map<String, ?> data) {
        StringBuilder sb = new StringBuilder();
        for (Map.Entry<String, ?> i : data.entrySet()) {
            try {
                sb.append(i.getKey()).append("=").append(URLEncoder.encode(i.getValue()+"","UTF-8")).append("&");
            } catch (UnsupportedEncodingException e) {
                e.printStackTrace();
            }
        }
        return sb.toString();
    }
}
